#include <stdio.h>
#include <string.h>
#include <math.h>
#include <sys/time.h>
#include <gtk/gtk.h>
#include <gnome.h>
#include <glade/glade.h>

#include <pthread.h>

#define PROGRAM_NAME    "Benchpress"
#define PROGRAM_VERSION "v0.0 (20080404)"

#define FILENAME  "/usr/share/benchpress/benchpress.glade"
#define ROOTNODE  "window_main"
#define PREFNODE  "window_prefs"
#define RESULTSNODE  "window_results"
#define ABOUTNODE "dialog_about"

#ifndef __GLOBAL_H__
#define __GLOBAL_H__

GladeXML *xml_main;
GladeXML *xml_prefs;
GladeXML *xml_about;
GladeXML *xml_results;


void set_statusbar(gchar *text);
void output_text(gchar *text, gchar *style);
void set_progress(gfloat progress);
void set_busy(gboolean busy);
void *sub_master(void *arg);
void *sub_monitor_total(void *arg);
void run_suite();
void init_text_view();
void set_test_name(gchar *text);

float get_sd(float *, int num);
float get_mean(float *, int num);
float get_peak(float *, int num);
float get_low(float *, int num);

gchar file_path[200];
unsigned char buffer[1024];

gboolean test_float;
gboolean test_integer;
gboolean test_disk;
gboolean test_gui;
gboolean test_opengl;

gboolean done;
gboolean fully_done;
pthread_mutex_t mutex_reps;
int reps;

GtkTextBuffer *tb;
GtkTextIter iter;
GtkTextMark *mark;

#endif

extern float int_test(float x);
extern float run_integer(int num_threads, int run_time);
extern float run_float(int num_threads, int run_time);
extern void *sub_monitor_total(void *arg);

extern GladeXML *xml_main;
extern GladeXML *xml_prefs;
extern GladeXML *xml_about;

extern gboolean test_whet_single;
extern gboolean test_whet_multi;

extern gboolean done;
extern gboolean fully_done;
extern pthread_mutex_t mutex_reps;
extern int reps;

